/*			 
		(c) 2005 by Dimitri Junker
			Adenauerallee 30
			53066 Aachen	*/

#define PRG_NAME	"DIR_LWR "
#define VERSION		104
#undef deutsch

/*	Rckgabe des Programms:
	0:	Alles OK
	<0 Fehler laut MY_ERR.H
*/
/* -------------------------------------------------------------------- */
/*		Includes														*/
/* -------------------------------------------------------------------- */
#include <stdio.h>
#include <aes.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <time.h>
#include <tos.h>
#include <assert.h>

/* -------------------------------------------------------------------- */
/*       Makros. & constants                                           */
/* -------------------------------------------------------------------- */
#define TRAPPER_CHECK  -1
#define TRAPPER_GEMDOS  2

#define TRAPPER_INSTALL_CALL    0
#define TRAPPER_INSTALL_RETURN  2

#define ERR_TRAP	-103			/*Kein Trapper o..			*/

#define	COOKIE_ID	'DYDL'
#define MAX_FCT	10
#define int32	long
#define int16	int
#define CDECL	cdecl

#define TRUE 1
#define FALSE 0

#define	E_OK	0

#define ERR_FS_KJAR	(-600)			/*kein Cookie Jar			*/
#define ERR_FS_COOK	(-601)			/*Fehler mit Cookies		*/
#define ERR_FS_SPEI	(-602)			/*zu Wenig Speicher			*/

#define MIN_HDLS 10
/* -------------------------------------------------------------------- */
/*		typedefs														*/
/* -------------------------------------------------------------------- */
typedef struct {
	int version;     /* BCD coded, e.g. 0x110 for Version 1.10 */
	int reserved[15];
} TrapperInfo;
typedef struct
{
	int 	layer;
	int 	install;
	int 	opcode;
	void 	*function;
}TR_FCT;
/*DYJ 1.02a Start*/
typedef struct
{
	long vHandle;
	int flag;
}HDLS;
typedef struct
{
	int		version;
	char	time[22];
	int		size;
	int 	anz;
	void	(*removeFkt)(void);
	TR_FCT	functions[MAX_FCT];
	HDLS	*hdls;
	int		maxHdls;
}DL_COOKIE;
/*DYJ  Ende; alt:	
typedef struct
{
	int		version;
	char	time[22];
	int		size;
	int 	anz;
	void	(*removeFkt)(void);
	TR_FCT	functions[MAX_FCT];
}DL_COOKIE;
typedef struct hdls
{
	long vHandle;
	int flag;
	struct hdls* nxt;
}HDLS;
*/
typedef int32 CDECL (*GemdosCallFunc)(int16 *para, int16 *call_original, int16 super_called);
typedef int32 CDECL (*GemdosReturnFunc)(int32 ret, int16 *para, int16 is_super);
typedef char	BOOL;


/* -------------------------------------------------------------------- */
/* 		lokale Funktions prototypes										*/
/* -------------------------------------------------------------------- */
long Trapper(int layer, int install, int opcode, void *function);
void removeAll(void);

/* -------------------------------------------------------------------- */
/*		Globale Variables												*/
/* -------------------------------------------------------------------- */
DL_COOKIE	*Dlc=NULL;
HDLS *Hdls=NULL;

/* -------------------------------------------------------------------- */
/*		Funktions														*/
/* -------------------------------------------------------------------- */
/*------------------------------------------------------------------*/
/*	long get_cookie_jar()											*/
/*																	*/
/*	Ermittelt die Adresse des Cookie Jar.							*/
/*																	*/
/*	Parameter:keine				 									*/
/*	Rckgabe :Adresse, falls der Cookie Jar gefunden wurde,			*/
/*			  NULL falls kein Cookie-Jar							*/
/*  Besonderheit: mu per Supexec aufgerufen werden					*/
/*	(c) by Dimitri Junker 1996										*/
/*------------------------------------------------------------------*/

long  get_cookie_jar()
{
	long *cookiejar;

	cookiejar = *((long **) 0x5a0L);
	return((long)cookiejar);
}

/*------------------------------------------------------------------*/
/*	long *get_cookie_ptr(BYTE *cookie_name)							*/
/*																	*/
/*	Sucht nach einem Cookie 'cookie_name' und liefert dessen 		*/
/*	Adresse zurck.													*/
/*																	*/
/*	Parameter:Name des Cookies 										*/
/*	Rckgabe :Adresse, falls der Cookie gefunden wurde,				*/
/*			  Adresse des NULL-cookie falls nicht vorhanden			*/
/*			  NULL falls kein Cookie-Jar							*/
/*	(c) by Dimitri Junker 1996										*/
/*------------------------------------------------------------------*/

long * get_cookie_ptr(long cookie_name)
{
	long *cookiejar;

	/* Zuerst einen Zeiger auf den Cookiejar holen */

	cookiejar= (long *)Supexec(get_cookie_jar);

	/* Ist der Cookiejar vorhanden ? */
    
	if(!cookiejar)
		return(NULL);
	else
	{
		do
		{
			/* Ist es unser Cookie ? */
			if(*cookiejar== cookie_name)
				break;
			else
			{
				/* nchster Cookie aus Jar */
				cookiejar = &(cookiejar[2]);
			}
		} 
		while(cookiejar[0]);  /* solange nicht NULL-Cookie */
    
		return(cookiejar);;
  }
}
/*------------------------------------------------------------------*/
/*	void del_cookie(long cookie_name)								*/
/*																	*/
/*	Lscht einen Cookie 'cookie_name'								*/
/*																	*/
/*	Parameter:Name des Cookies										*/
/*	(c) by Dimitri Junker 1996										*/
/*------------------------------------------------------------------*/

void del_cookie(long cookie_name)
{
	long *cookie;
	/* Prfen ob er bereits existiert:	*/
	if((cookie=get_cookie_ptr(cookie_name))!=NULL)
	{	while(cookie[0])
		{	cookie[0]=cookie[2];
			cookie[1]=cookie[3];
			cookie=&cookie[2];
		}
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	void removeAll(void)														*/
/*	Entfernt alle Funktionen wieder												*/
/*	Parameter: keine															*/
/*	Ergebnis: keins																*/		
/*	23.9.03 von Dimitri Junker	DYJ 0.21b										*/
/*** ------------------------------------------------------------------------ ***/
void removeAll(void)
{

/*	Funktionen deinstalieren	*/
	while(Dlc->anz--)
	{
		if((Dlc->functions[Dlc->anz].layer &0xfffC) ==0)
		{
			if(Trapper(Dlc->functions[Dlc->anz].layer, Dlc->functions[Dlc->anz].install+1, Dlc->functions[Dlc->anz].opcode, Dlc->functions[Dlc->anz].function)!=E_OK)
#ifdef deutsch
				printf("Fehler in removeAll\n");
#else
				printf("Err in removeAll\n");
#endif
		}
	}
/*  Speicher von Handelliste freigeben*/
	if(Dlc->hdls)
		free(Dlc->hdls);
/* Cookie entfernen + Speicher freigeben*/
	Dlc->anz=0;
	del_cookie(COOKIE_ID);
	free(Dlc);
	Dlc=NULL;
}
	
long TrapperSC(int layer, int install, int opcode, void *function)
{
	assert(Dlc->anz<Dlc->size);
	Dlc->functions[Dlc->anz].layer=layer;
	Dlc->functions[Dlc->anz].install=install;
	Dlc->functions[Dlc->anz].opcode=opcode;
	Dlc->functions[Dlc->anz].function=function;
	Dlc->anz++;
	return Trapper(layer,install,opcode,function);
}
long TrapperInstallGemdosCall(int opcode, GemdosCallFunc func)
{
	return TrapperSC(TRAPPER_GEMDOS, TRAPPER_INSTALL_CALL, opcode, func);
}
long TrapperInstallGemdosReturn(int opcode, GemdosReturnFunc func)
{
	return TrapperSC(TRAPPER_GEMDOS, TRAPPER_INSTALL_RETURN, opcode, func);
}
HDLS *findHdl(long hdl)
{
	HDLS* ret=NULL;
	int i;
	for(i=0;i<Dlc->maxHdls;i++)
	{
		if(Dlc->hdls[i].vHandle==hdl)
		{
			ret=&Dlc->hdls[i];
			break;
		}
	}
	if(!ret&&hdl==-1)
	{
		ret=Mxalloc(sizeof(HDLS)*(Dlc->maxHdls+MIN_HDLS),0x28);
		if(ret)
		{
			memcpy(ret,Dlc->hdls,sizeof(HDLS)*Dlc->maxHdls);
			free(Dlc->hdls);
			Dlc->hdls=ret;
			ret=&Dlc->hdls[Dlc->maxHdls];
			Dlc->maxHdls+=MIN_HDLS;
			for(i=0;i<MIN_HDLS;i++)
				ret[i].vHandle=-1;
		}
	}
	return ret;
}
#pragma warn -par

/*** ------------------------------------------------------------------------ ***/
/*	int32 CDECL vorDxopendir(int16 *para, int16 *call_original, int16 super_called)	*/
/*	statt Dopendir(296)														*/
/*	Parameter:	die blichen, s. Trapper - Info									*/
/*	Ergebnis:	s. Trapper - Info												*/		
/*	25.11.05 von Dimitri Junker									*/
/*** ------------------------------------------------------------------------ ***/
long cdecl vorDxopendir(int *para, int *call_original, int super_called)
{
	long ret=Dopendir(*((char**)(&(para[1]))),para[3]);
	
	HDLS *hdls=findHdl(-1);
	if(hdls)
	{
		hdls->vHandle=ret;
		hdls->flag=para[3];
	}
	*call_original=FALSE;
	return ret;
}

/*** ------------------------------------------------------------------------ ***/
/*	int32 CDECL vorDclosedir(int16 *para, int16 *call_original, int16 super_called)	*/
/*	wird vor Dclosedir(299)	Speicher freigeben									*/
/*	Parameter:	die blichen, s. Trapper - Info									*/
/*	Ergebnis:	s. Trapper - Info												*/		
/*	25.11.05 von Dimitri Junker									*/
/*** ------------------------------------------------------------------------ ***/
long cdecl vorDclosedir(int *para, int *call_original, int super_called)
{
	HDLS *hdl=findHdl((*((long*)(&(para[1])))));
	if(hdl)
		hdl->vHandle=-1;
	return 0;
}
/*** ------------------------------------------------------------------------ ***/
/*	long cdecl nachD_readdir(long ret, int *para, int is_super)					*/
/*	wird nach Dreaddir(297) und Dxreaddir (322) aufgerufen						*/
/*	Falls Handle in der Liste wird der Filename in Kleinbuchstaben gewandelt	*/
/*	Parameter:	die blichen, s. Trapper - Info									*/
/*	Ergebnis:	s. Trapper - Info												*/		
/*	25.11.05 von Dimitri Junker													*/
/*** ------------------------------------------------------------------------ ***/
long cdecl nachD_readdir(long ret, int *para, int is_super)
{
	if(ret==E_OK)
	{
		HDLS *akt=findHdl((*((long*)(&(para[2])))));
		if(akt)
		{
			char *fName=*((char**)(&(para[4])));
			if(!akt->flag)
				fName+=4;
			strlwr(fName);
		}
	}
	return ret;
}
#pragma warn +par

/*------------------------------------------------------------------*/
/*	BOOLEAN get_cookie(long cookie_name, LONG *cookie_value)		*/
/*																	*/
/*	Sucht nach einem Cookie 'cookie_name' und liefert dessen Wert	*/
/*	in 'cookie_value' zurck.										*/
/*																	*/
/*	Parameter:Name des Cookies und einen Zeiger auf den Wert des	*/
/*						Cookies.									*/
/*	Rckgabe :TRUE, falls der Cookie gefunden wurde, FALSE falls	*/
/*						nicht.										*/
/*					In 'cookie_value' steht der Wert des Cookies.	*/
/*					cookie_value kann NULL sein, dann wird nur die	*/
/*					Existenz des Cookies getestet					*/
/*------------------------------------------------------------------*/

BOOL get_cookie(long cookie_name, long *cookie_value)
{
	long *cookie;
	int ret=1;
	
	/* Zuerst einen Zeiger auf den Cookie holen */

	cookie = get_cookie_ptr(cookie_name);

	/* Ist der Cookiejar vorhanden ? */
    
	if(!cookie)
		ret=0;
	else
	{	if(!cookie[0])
			ret=0;
		else
		{	if(cookie_value)
				*cookie_value=cookie[1];
		}
	}
	return(ret);
}

/*------------------------------------------------------------------*/
/*	int set_cookie(long cookie_name, LONG cookie_value)		*/
/*																	*/
/*	Setzt einen Cookie 'cookie_name' auf den Wert cookie_value		*/
/*																	*/
/*	Parameter:Name des Cookies und den Wert des	Cookies.			*/
/*	Rckgabe :0, falls der Cookie gesetzt werden konnte, 			*/
/*			  ERR_FS_KJAR falls	kein Cookie Jar vorhanden 			*/
/*			  ERR_FS_COOK falls cookie_name bereits vorhanden		*/
/*			  ERR_FS_SPEI falls nicht genug Speicher fr greren Jar*/
/*	(c) by Dimitri Junker 1996										*/
/*------------------------------------------------------------------*/

int set_cookie(long cookie_name, long cookie_value)
{	int err=0;
	long *cookie,*old_jar,*new_jar,len;
	/* Prfen ob er bereits existiert:	*/
	if((cookie=get_cookie_ptr(cookie_name))==NULL)
		err=ERR_FS_KJAR;
	else
	{	if(*cookie)
			err=ERR_FS_COOK;
	}
	/* ggf greren Jar anlegen		*/
	if(!err)
	{	old_jar=(long *)Supexec(get_cookie_jar);
		len=(long)cookie-(long)old_jar;
		if(len<(cookie[1]-1)*8l)
		{	cookie[2]=cookie[0];
			cookie[3]=cookie[1];
		}
		else	/* vergrern	*/
		{	len=cookie[1]+20;
			if((new_jar=malloc(len*8l))==NULL)
				err=ERR_FS_SPEI;
			else
			{	memcpy(new_jar,old_jar,cookie[1]*8l);
				cookie=&new_jar[((int)cookie[1]-1)*2];
				cookie[2]=0l;
				cookie[3]=len;
			}
		}
	}
	if(!err)
	{	cookie[0]=cookie_name;
		cookie[1]=cookie_value;
	}
	return(err);
}
int main(void)
{
	int err=0,appl_id;
	TrapperInfo ti;
	_GemParBlk.global[0]=0;
	appl_id=appl_init();
	if(!_GemParBlk.global[0])
	{
		appl_id=-1;
		printf("%s Version: %.2f by Dimitri Junker\n",PRG_NAME,((float)VERSION)/100);
	}
	if(Trapper(TRAPPER_CHECK,0,0,&ti))
	{
#ifdef deutsch
		if(appl_id>=0)
			form_alert(1,"[3][Trapper nicht gefunden][Abbruch]");
		else
			printf("dir_lwr:Trapper nicht gefunden\n");
#else
		if(appl_id>=0)
			form_alert(1,"[3][Trapper not found][Cancel]");
		else
			printf("dir_lwr:Trapper not found\n");
#endif
		err=ERR_TRAP;
	}
	else
	{
		char zeitSt[22];
		strncpy(zeitSt,__DATE__ " " __TIME__,sizeof(zeitSt));
		if(get_cookie(COOKIE_ID,(long *)&Dlc))
		{
			if(appl_id<0)
				exit(0);
			if(!strcmp(zeitSt,Dlc->time))
			{

#ifdef deutsch
				if(form_alert(2,"[2][Dir_Lwr ist bereits installiert!|Deinstallieren?][Deinst.|Abbruch]")==1)
#else
				if(form_alert(2,"[2][Dir_Lwr already installed!|Deinstall?][Deinstall|cancel]")==1)
#endif
					Dlc->removeFkt();
				exit(0);
			}
			else
				Dlc->removeFkt();
		}
		Dlc=Mxalloc(sizeof(DL_COOKIE),0x28);
		if(Dlc)
		{
			Dlc->hdls=Mxalloc(sizeof(HDLS)*MIN_HDLS,0x28);
			if(Dlc->hdls)
			{
				int i;
				for(i=0;i<MIN_HDLS;i++)
					Dlc->hdls[i].vHandle=-1;
				Dlc->maxHdls=MIN_HDLS;
			}
			else
				exit(0);
			set_cookie(COOKIE_ID,(long)Dlc);
			Dlc->removeFkt=removeAll;
			Dlc->anz=0;
			Dlc->version=VERSION;
			strncpy(Dlc->time,zeitSt,sizeof(Dlc->time));
			Dlc->size=MAX_FCT;
			TrapperInstallGemdosCall(1296,vorDxopendir);
			TrapperInstallGemdosCall(299,vorDclosedir);
			TrapperInstallGemdosReturn(297,nachD_readdir);
			TrapperInstallGemdosReturn(322,nachD_readdir);
		}
		else
			exit(0);
		Ptermres(_PgmSize+20000,0);
	}
	appl_exit();
	return err;
}